<?php

class twitter{
    var $username='';
    var $password='';
    var $user_agent='';

    var $headers=array('X-Twitter-Client:',
                       'X-Twitter-Client-Version:',
                       'X-Twitter-Client-URL:');

    /*
     * Por el momento no funciona lo de mandar el cliente asi.
     */

    var $responseInfo=array();
    var $returnType='';


    // Establece el formato de retorno de todas las funciones
	//Valores posibles: RAWXML, ARRAYXML, OBJECTXML
	//
	function twitter($returnType) {
		$this->returnType = strtoupper($returnType);
	}


    // Actualiza el estado del usuario autentificado.
	//
    function update($status){
        $request = 'http://twitter.com/statuses/update.xml';
        $postargs = 'status='.urlencode($status);
        return $this->process($request,$postargs);
    }

	//
    //Devuelve los ultimos 20 estados de usuarios que tengan avatar.
    //
    //

    function publicTimeline($sinceid=false){
        $qs='';
        if($sinceid!==false)
            $qs='?since_id='.intval($sinceid);
        $request = 'http://twitter.com/statuses/public_timeline.xml'.$qs;
        return $this->process($request);
    }

    function replies($user,$pass,$sinceid=false){
        $qs='';
        if($sinceid!==false)
            $qs='?since_id='.intval($sinceid);
        $request = 'http://'.$user.":".$pass."@".'twitter.com/statuses/replies.xml'.$qs;
        return $this->process($request);
    }

	//Devuelve los 20 ultimos estados del usuario y sus amigos.



    function friendsTimeline($sinceid=false){

         $qs='';
        if($sinceid!==false)
            $qs='?since_id='.intval($sinceid);
        $request = 'http://twitter.com/statuses/friends_timeline.xml'.$qs;
        return $this->process($request);
    }

	//
    // Devuelve los 20 ultimos estados de un usuario.
 	//

    function userTimeline($id=false,$count=20,$since=false){
        $qs='?count='.intval($count);
        if($since!==false)
            $qs .= '&since='.urlencode($since);

        if($id===false)
            $request = 'http://twitter.com/statuses/user_timeline.xml'.$qs;
        else
            $request = 'http://twitter.com/statuses/user_timeline/'.urlencode($id).'.xml'.$qs;

        return $this->process($request);
    }

   	//devuelve el estado con esa id

    function showStatus($id){
        $request = 'http://twitter.com/statuses/show/'.intval($id).'.xml';
        return $this->process($request);
    }


    function friends($id=false){
        if($id===false)
            $request = 'http://twitter.com/statuses/friends.xml';
        else
            $request = 'http://twitter.com/statuses/friends/'.urlencode($id).'.xml';
        return $this->process($request);
    }

    // Devuelve una lista de tus followers con el estado actual
    //

    function followers(){
        $request = 'http://twitter.com/statuses/followers.xml';
        return $this->process($request);
    }

    // Returns a list of the users currently featured on the site with their current statuses inline.
    function featured(){
        $request = 'http://twitter.com/statuses/featured.xml';
        return $this->process($request);
    }

    //Devuelve la informacion del usuario.

    function showUser($id){
        $request = 'http://twitter.com/users/show/'.urlencode($id).'.xml';
        return $this->process($request);
    }

	//
    // Para recuperar los mensajes directos
    //

    function directMessages($since=false){
        $qs='';
        if($since!==false)
            $qs='?since='.urlencode($since);
        $request = 'http://twitter.com/direct_messages.xml'.$qs;
        return $this->process($request);
    }

    // Para enviar mensajes directos

    function sendDirectMessage($user,$text){
        $request = 'http://twitter.com/direct_messages/new.xml';
        $postargs = 'user='.urlencode($user).'&text='.urlencode($text);
        return $this->process($request,$postargs);
    }

	//Funciones para crear y destruir las relacciones.

    function nofriend($user){
    	$request = 'http://twitter.com/friendships/destroy/'.$user.'.xml';
        return $this->process($request);
    }
    function befriend($user){
    	$request = 'http://twitter.com/friendships/create/'.$user.'.xml';
        return $this->process($request);
    }





    // internal function where all the juicy curl fun takes place
    // this should not be called by anything external unless you are
    // doing something else completely then knock youself out.
    function process($url,$postargs=false){

        $ch = curl_init($url);

        if($postargs !== false){
            curl_setopt ($ch, CURLOPT_POST, true);
            curl_setopt ($ch, CURLOPT_POSTFIELDS, $postargs);
        }

        if($this->username !== false && $this->password !== false)
            curl_setopt($ch, CURLOPT_USERPWD, $this->username.':'.$this->password);

        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_NOBODY, 0);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_USERAGENT, $this->user_agent);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION,1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $this->headers);

        $response = curl_exec($ch);

        $this->responseInfo=curl_getinfo($ch);
        curl_close($ch);

        if(intval($this->responseInfo['http_code'])==200){
			switch ($this->returnType) {
				case 'OBJECTXML':
					if (class_exists('SimpleXMLElement')) {
						$xml = new SimpleXMLElement($response);
					} else {
						$xml = $response;
					}
					break;
				case 'ARRAYXML':
					if ($xmlparser = xml_parser_create()) {
						$objXML = new xml2Array();
						$arrOutput = $objXML->parse($response);
						$xml = $arrOutput;
					} else {
						$xml = $response;
					}
					break;
				case 'RAWXML':
					$xml = $response;
					break;
				default:
					$xml = $response;
					break;
			}
			return $xml;

        }else{
            return false;
        }
    }
}

/*
	Usage:
 	Grab some XML data, either from a file, URL, etc. however you want. Assume storage in $strYourXML;
 	Thanks to PHP.net for offering the code as a solution

 	SampleCode:
 	$objXML = new xml2Array();
 	$arrOutput = $objXML->parse($strYourXML);
 	print_r($arrOutput); //print it out, or do whatever!
*/

class xml2Array {

    var $arrOutput = array();
    var $resParser;
    var $strXmlData;

    function parse($strInputXML) {

            $this->resParser = xml_parser_create ();
            xml_set_object($this->resParser,$this);
            xml_set_element_handler($this->resParser, "tagOpen", "tagClosed");

            xml_set_character_data_handler($this->resParser, "tagData");

            $this->strXmlData = xml_parse($this->resParser,$strInputXML );
            if(!$this->strXmlData) {
               die(sprintf("XML error: %s at line %d",
            xml_error_string(xml_get_error_code($this->resParser)),
            xml_get_current_line_number($this->resParser)));
            }

            xml_parser_free($this->resParser);

            return $this->arrOutput;
    }

    function tagOpen($parser, $name, $attrs) {
       $tag=array("name"=>$name,"attrs"=>$attrs);
       array_push($this->arrOutput,$tag);
    }

    function tagData($parser, $tagData) {
       if(trim($tagData)) {
            if(isset($this->arrOutput[count($this->arrOutput)-1]['tagData'])) {
                $this->arrOutput[count($this->arrOutput)-1]['tagData'] .= $tagData;
            }
            else {
                $this->arrOutput[count($this->arrOutput)-1]['tagData'] = $tagData;
            }
       }
    }

    function tagClosed($parser, $name) {
       $this->arrOutput[count($this->arrOutput)-2]['children'][] = $this->arrOutput[count($this->arrOutput)-1];
       array_pop($this->arrOutput);
    }
}
?>